# Copyright (c) 2012 The Chromium Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

# Autocompletion config for YouCompleteMe in Android.
#
# USAGE:
#
#   1. Install YCM [https://github.com/Valloric/YouCompleteMe]
#          (Googlers should check out [go/ycm])
#
#   2. Create a symbolic link to this file called .ycm_extra_conf.py in the
#      directory above your Android checkout (i.e. next to your .gclient file).
#
#          cd src
#          ln -rs tools/vim/chromium.ycm_extra_conf.py ../.ycm_extra_conf.py
#
#   3. (optional) Whitelist the .ycm_extra_conf.py from step #2 by adding the
#      following to your .vimrc:
#
#          let g:ycm_extra_conf_globlist=['<path to .ycm_extra_conf.py>']
#
#      You can also add other .ycm_extra_conf.py files you want to use to this
#      list to prevent excessive prompting each time you visit a directory
#      covered by a config file.
#
#   4. Profit
#
#
# Usage notes:
#
#   * You must have built Android recently.
#
#
# Hacking notes:
#
#   * The purpose of this script is to construct an accurate enough command line
#     for YCM to pass to clang so it can build and extract the symbols.
#
#   * Right now, we only pull the -I and -D flags. That seems to be sufficient
#     for everything I've used it for.
#
#   * This has only been tested on gPrecise.

from __future__ import print_function

import os
import os.path
import subprocess
import sys

# Flags from YCM's default config.
_default_flags = [
    '-DUSE_CLANG_COMPLETER',
    '-std=c++11',
    '-x',
    'c++',
]


def PathExists(*args):
  return os.path.exists(os.path.join(*args))


def FindAndroidRootFromFilename(filename):
  """Searches for the root of the Android checkout.

  Simply checks parent directories until it finds .repo.

  Args:
    filename: (String) Path to source file being edited.

  Returns:
    (String) Path of Android checkout, or None if unable to find.
  """
  curdir = os.path.normpath(os.path.dirname(filename))
  while not PathExists(curdir, '.repo'):
    nextdir = os.path.normpath(os.path.join(curdir, '..'))
    if nextdir == curdir:
      return None
    curdir = nextdir
  return curdir


def GetDefaultSourceFile(android_root, filename):
  """Returns the default source file to use as an alternative to |filename|.

  Compile flags used to build the default source file is assumed to be a
  close-enough approximation for building |filename|.

  Args:
    android_root: (String) Absolute path to the root of Android checkout.
    filename: (String) Absolute path to the source file.

  Returns:
    (String) Absolute path to substitute source file.
  """
  arcbridge_root = os.path.join(android_root, 'device/google/cheets2/arcbridge')
  if filename.startswith(arcbridge_root):
    return os.path.join(arcbridge_root, 'arcbridgeservice', 'main.cpp')
  else:
    return os.path.join(android_root, 'system', 'core', 'libutils',
                        'Threads.cpp')


def GetBuildableSourceFile(android_root, filename):
  """Returns a buildable source file corresponding to |filename|.

  A buildable source file is one which is likely to be passed into clang/g++ as
  a source file during the build. For .h files, returns the closest matching
  .cc, .cpp or .c file. If no such file is found, returns the same as
  GetDefaultSourceFile().

  Args:
    android_root: (String) Absolute path to the root of Android checkout.
    filename: (String) Absolute path to the target source file.

  Returns:
    (String) Absolute path to source file.
  """
  if filename.endswith('.h'):
    # Header files can't be built. Instead, try to match a header file to its
    # corresponding source file.
    alternates = ['.cc', '.cpp', '.c']
    for alt_extension in alternates:
      alt_name = filename[:-2] + alt_extension
      if os.path.exists(alt_name):
        return alt_name

    return GetDefaultSourceFile(android_root, filename)

  return filename


def GetNinjaBuildOutputsForSourceFile(android_root, ninja_file, filename):
  """Returns a list of build outputs for filename.

  The list is generated by invoking 'ninja -t query' tool to retrieve a list of
  inputs and outputs of |filename|. This list is then filtered to only include
  .o and .obj outputs.

  Args:
    android_root: (String) Absolute path to Android checkout directory.
    ninja_file: (String) Absolute path to ninja build file.
    filename: (String) Absolute path to source file.

  Returns:
    (List of Strings) List of target names. Will return [] if |filename| doesn't
        yield any .o or .obj outputs.
  """
  # Ninja needs the path to the source file relative to the output build
  # directory.
  rel_filename = os.path.relpath(os.path.realpath(filename), android_root)

  p = subprocess.Popen(['ninja', '-f', ninja_file, '-t', 'query', rel_filename],
                       stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
  stdout, _ = p.communicate()
  if p.returncode:
    return []

  # The output looks like:
  #   ../../relative/path/to/source.cc:
  #     outputs:
  #       obj/reative/path/to/target.source.o
  #       obj/some/other/target2.source.o
  #       another/target.txt
  #
  outputs_text = stdout.partition('\n  outputs:\n')[2]
  output_lines = [line.strip() for line in outputs_text.split('\n')]
  return [target for target in output_lines
          if target and (target.endswith('.o') or target.endswith('.obj'))]


def GetCompileCommandLineForNinjaOutput(ninja_file, build_target):
  """Returns the compile command line for building |build_target|

  Asks ninja for the list of commands used to build |filename| and returns the
  final compiler invocation.

  Args:
    ninja_file: (String) Absolute path to ninja build output directory.
    build_target: (String) A build target understood by ninja

  Returns:
    (String or None) compile command line or None if a compile command line
        couldn't be determined.
  """
  p = subprocess.Popen(['ninja', '-v', '-f', ninja_file,
                        '-t', 'commands', build_target],
                       stdout=subprocess.PIPE)
  stdout, _ = p.communicate()
  if p.returncode:
    return None

  # Ninja will return multiple build steps for all dependencies up to
  # |build_target|. The build step we want is the last compile invocation, which
  # is expected to be the one that outputs |build_target|.
  for line in reversed(stdout.split('\n')):
    if 'clang' in line or 'g++' in line:
      return line
  return None


def GetCompileCommandLineFromNinjaForSource(android_root, ninja_file, filename):
  """Returns a compile command line used to build |filename|.

  The same source file could be built multiple times using different tool
  chains. In such cases, this command returns the first compile invocation. We
  currently don't prefer one toolchain over another. Hopefully the tool chain
  corresponding to the compile command line is compatible with the compile build
  used by YCM.

  Args:
    android_root: (String) Absolute path to Android checkout.
    ninja_file: (String) Absolute path to the ninja file used.
    filename: (String) Absolute path to source file.

  Returns:
    (String or None): Command line for compile invocation using |filename| as a
        source. Returns None if no such command line could be found.
  """
  build_targets = GetNinjaBuildOutputsForSourceFile(android_root, ninja_file,
                                                    filename)
  for build_target in build_targets:
    command_line = GetCompileCommandLineForNinjaOutput(ninja_file, build_target)
    if command_line:
      return command_line
  return None


def GetCompileOptionsFromCommandLine(compile_commandline, android_root,
                                     ninja_file, additional_flags):
  """Extracts relevant command line options from |compile_commandline|

  Args:
    compile_commandline: (String) Full compile invocation.
    android_root: (String) Absolute path to Android checkout.
    ninja_file: (String) Absolute path to ninja build file. Relative paths in
        the command line are relative to |ninja_file|.
    additional_flags: (List of String) Additional flags to return.

  Returns:
    (List of Strings) The list of command line flags for this source file. Can
    be empty.
  """
  compile_flags = [] + additional_flags

  # Parse flags that are important for YCM's purposes. Unfortunately, shlex is
  # not usable in this scenario since Android build commands are complex and use
  # subshells liberally. Fall back to just splitting by spaces and hope for the
  # best.
  commandline_tokens = compile_commandline.split()
  for flag_index, flag in enumerate(commandline_tokens):
    if flag.startswith('-I'):
      if len(flag) == 2:
        filename = commandline_tokens[flag_index + 1]
      else:
        filename = flag[2:]
      # Relative paths need to be resolved, because they're relative to the
      # output dir, not the source.
      if not filename.startswith('/'):
        filename = os.path.normpath(os.path.join(android_root, filename))
      compile_flags.append('-I' + filename)
    elif flag == '-isystem':
      filename = commandline_tokens[flag_index + 1]
      # Relative paths need to be resolved, because they're relative to the
      # output dir, not the source.
      if not filename.startswith('/'):
        filename = os.path.normpath(os.path.join(android_root, filename))
      compile_flags.append('-isystem')
      compile_flags.append(filename)
    elif flag.startswith('-std'):
      compile_flags.append(flag)
    elif flag.startswith('-') and flag[1] in 'DWFfmO':
      if flag == '-Wno-deprecated-register' or flag == '-Wno-header-guard':
        # These flags causes libclang (3.3) to crash. Remove it until things
        # are fixed.
        continue
      compile_flags.append(flag)
    elif flag == '-isysroot':
      # On Mac -isysroot <path> is used to find the system headers.
      # Copy over both flags.
      if flag_index + 1 < len(commandline_tokens):
        compile_flags.append(flag)
        compile_flags.append(commandline_tokens[flag_index + 1])
    elif flag.startswith('--sysroot='):
      # On Linux we use a sysroot image.
      sysroot_path = flag.lstrip('--sysroot=')
      if sysroot_path.startswith('/'):
        compile_flags.append(flag)
      else:
        abs_path = os.path.normpath(os.path.join(ninja_file, sysroot_path))
        compile_flags.append('--sysroot=' + abs_path)
  return compile_flags


def GetNinjaFile(android_root):
  SUPPORTED_TARGETS = ['cheets_arm', 'cheets_x86']
  ninja_files = []
  for target in SUPPORTED_TARGETS:
    ninja_file = os.path.join(android_root, 'out', 'build-%s.ninja' % target)
    if not os.path.isfile(ninja_file):
      continue
    ninja_files.append(ninja_file)
  if not ninja_files:
    return None
  # Return the path of the newest ninja file.
  return max(ninja_files, key=lambda path: os.path.getmtime(path))


def GetCompileOptionsFromNinjaForFilename(android_root, filename):
  """Returns the compile command line options needed for building |filename|.

  Command line options are based on the command used by ninja for building
  |filename|. If |filename| is a .h file, uses its companion .cc or .cpp file.
  If a suitable companion file can't be located or if ninja doesn't know about
  |filename|, then uses default source files in Blink and Android for
  determining the commandline.

  Args:
    android_root: (String) Path to src/.
    filename: (String) Absolute path to source file being edited.

  Returns:
    (List of Strings) The list of command line flags for this source file. Can
    be empty.
  """
  if not android_root:
    return []

  additional_flags = []

  # Version of Clang used to compile Android can be newer then version of
  # libclang that YCM uses for completion. So it's possible that YCM's libclang
  # doesn't know about some used warning options, which causes compilation
  # warnings (and errors, because of '-Werror');
  additional_flags.append('-Wno-unknown-warning-option')

  sys.path.append(os.path.join(android_root, 'tools', 'vim'))
  ninja_file = os.path.realpath(GetNinjaFile(android_root))

  if not ninja_file:
    return []

  compile_line = GetCompileCommandLineFromNinjaForSource(
      android_root, ninja_file, GetBuildableSourceFile(android_root, filename))
  if not compile_line:
    # If ninja didn't know about filename or it's companion files, then try a
    # default build target. It is possible that the file is new, or build.ninja
    # is stale.
    compile_line = GetCompileCommandLineFromNinjaForSource(
        android_root, ninja_file, GetDefaultSourceFile(android_root, filename))

  if not compile_line:
    return additional_flags

  return GetCompileOptionsFromCommandLine(compile_line, android_root,
                                          ninja_file, additional_flags)


def FlagsForFile(filename):
  """This is the main entry point for YCM. Its interface is fixed.

  Args:
    filename: (String) Path to source file being edited.

  Returns:
    (Dictionary)
      'flags': (List of Strings) Command line flags.
      'do_cache': (Boolean) True if the result should be cached.
  """
  abs_filename = os.path.abspath(filename)
  android_root = FindAndroidRootFromFilename(abs_filename)
  compile_flags = GetCompileOptionsFromNinjaForFilename(android_root,
                                                        abs_filename)

  # If compile_flags could not be determined, then assume that was due to a
  # transient failure. Preventing YCM from caching the flags allows us to try to
  # determine the flags again.
  should_cache_flags_for_file = bool(compile_flags)

  final_flags = _default_flags + compile_flags

  return {
      'flags': final_flags,
      'do_cache': should_cache_flags_for_file
  }

if __name__ == '__main__':
  print(FlagsForFile(sys.argv[1]))
